#ifndef __AnatomicalImage_cxx
#define __AnatomicalImage_cxx

#include "AnatomicalImage.h"


/*********************************************************************/
AnatomicalImage::AnatomicalImage()
{
	this->Name = new char[1000];  //Display name
	this->InputDirectory = new char[1000];
	this->OutputDirectory = new char[1000];
	this->OutputFileName = new char[1000];
	this->InputFileName = new char[1000];

	this->ITKImage = ITKImageType::New();
	this->Image = vtkKWImage::New();

}
/*********************************************************************/
AnatomicalImage::~AnatomicalImage() 
{

}
/*********************************************************************/
void AnatomicalImage::SetDisplayName(const char * fileName)
{
	strcpy(this->Name, fileName);
}
/*********************************************************************/
void AnatomicalImage::Update()
{
}
/*********************************************************************/
ITKImageType::Pointer AnatomicalImage::GetITKImage()
{
	return this->ITKImage;
}
/*********************************************************************/
vtkKWImage * AnatomicalImage::GetImage()
{
	return this->Image;
}
/*********************************************************************/
char * AnatomicalImage::GetName()
{
	return this->Name;
}
/*********************************************************************/
char * AnatomicalImage::GetInputDirectory()
{
	return this->InputDirectory;
}
/*********************************************************************/
void AnatomicalImage::SetInputDirectory(char * dirName)
{
	strcpy(this->InputDirectory,dirName);
}
/*********************************************************************/
char * AnatomicalImage::GetOutputLocation()
{
	return this->OutputDirectory;
}
/*********************************************************************/
void AnatomicalImage::SetOutputFileName(char * dirName, char * fileName)
{
	strcpy(this->OutputDirectory,dirName);
	strcpy(this->OutputFileName,fileName);
}
/*********************************************************************/
void AnatomicalImage::SetOutputPath(char * dirName)
{
	strcpy(this->OutputDirectory,dirName);
}
/*********************************************************************/
void AnatomicalImage::LoadImageFile(char * pathName)
{
	
}
/*********************************************************************/
void AnatomicalImage::SetImage(vtkKWImage * input)
{
	this->Image = input;
	SetITKImage(input);
}
/*********************************************************************
void AnatomicalImage::SetImage(vtkImageData *)
{
}
/*********************************************************************/
void AnatomicalImage::SetImage(ITKImageType::Pointer input)
{
	this->ITKImage = input;
	this->Image->SetITKImageBase(input);
}
/*********************************************************************/

void AnatomicalImage::SetITKImage(vtkKWImage * image)
{	
	ITKImageType::Pointer output = ITKImageType::New();
	const ITKImageType * testImage = static_cast< const ITKImageType * >(image->GetITKImageBase() );
	output = const_cast<ITKImageType *>(testImage);
	this->ITKImage = output;
}

#endif
